//Coded by repat, 240108
//TIMER.ENABLED:=TRUE(!)
unit xplanetbatch_Unit;

interface
//uses ShellAPI for ShellExecute()
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DFTrayIcon, Menus, ExtCtrls, ShellAPI, Spin, XPMan;

type
  TForm1 = class(TForm)
    DFTrayIcon1: TDFTrayIcon;
    tray_button: TButton;
    PopupMenu1: TPopupMenu;
    Exit1: TMenuItem;
    Visible1: TMenuItem;
    Timer1: TTimer;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    MainMenu1: TMainMenu;
    DAtei1: TMenuItem;
    Hilfe1: TMenuItem;
    About1: TMenuItem;
    Exit2: TMenuItem;
    oeffnen_button: TButton;
    batedit_button: TButton;
    Timer2: TTimer;
    SpinButton1: TSpinButton;
    Edit2: TEdit;
    Readme1: TMenuItem;
    Jetztupdaten1: TMenuItem;
    procedure tray_buttonClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Visible1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure batedit_buttonClick(Sender: TObject);
    procedure oeffnen_buttonClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure DFTrayIcon1DblClick(Sender: TObject);
    procedure zahlaendern();
    procedure Readme1Click(Sender: TObject);
    procedure Jetztupdaten1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  //Fr Aktualisierung
  aktintervall: Integer;
  //Wird in mehreren Funktionen gebraucht
  configFile: TextFile;
  //Inhalt als integer, weil nur die Minutenanzahl in der Datei steht
  inhalt: integer;

implementation

uses xplanetbatch_unit2;

{$R *.dfm}


//-----------------------Beginn Haupt-Code---------------------------//


procedure TForm1.FormCreate(Sender: TObject);
begin
  //Pfad in dem das Programm sich befindet auslesen
  //Nach Installation mit Install-Prog ist das derselbe Pfad dieser Exe
  edit1.text:=extractfilepath(application.Exename);
  //Tray-Icon Erschaffen
  DFTrayIcon1.Active:=True;
  //Macht Config-Fenster invis
  timer2.Enabled:=true;

  //Nach Konfiguration gucken und evtl. laden

  if FileExists('config.txt') then
  begin
    AssignFile(configFile, 'config.txt');
    Reset(configFile);
    ReadLn(configFile,inhalt);
    edit2.text:=inttostr(inhalt);
    CloseFile(configFile);
  end
  else
  begin
    AssignFile(configFile, 'config.txt');
    ReWrite(configFile);
    Write(configFile, edit2.text);
    CloseFile(configFile);
  end;

  //aktuelles Intervall laden
  aktintervall:=strtoint(edit2.text);
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  //Fr den Anfang die Form invis setzen und den Timer dann deaktivieren
  form1.Visible:=false;
  timer2.Enabled:=false;
end;

//Das eigentliche Laden des Hintergrundbildes
procedure TForm1.Timer1Timer(Sender: TObject);
var
  e: INTEGER;
begin
  e := ShellExecute
         (Handle,
          NIL,
          //Konfig-Pfad+Script->ausfhren
          PCHAR(edit1.text+'xplanet.bat'),
          PCHAR(''),
          NIL,
          SW_SHOW);
  IF (e<=32) THEN
    begin
      ShowMessage('Fehler: Batch-Datei konnte nicht ausgefhrt werden! xplanet.bat muss im selben Ordner wie dieses Programm und xplanet.exe liegen!')
    end;
end;

procedure TForm1.zahlaendern();
begin
   //Intervall aktualisieren
  assignfile(configFile, 'config.txt');
  Rewrite(configFile);//ging nicht anders(?)
  writeln(configFile, edit2.text);
  CloseFile(configFile);

  //Minuten-Anzahl*60 fr Sekunden*1000 fr Milisek
  aktintervall:=strtoint(edit2.text);
  Timer1.Interval:=aktintervall*1000*60;
end;

procedure TForm1.SpinButton1DownClick(Sender: TObject);
var
  //in edit-Feldern sind strings, deswegen kann hier kein integer genommen werden
  temp:integer;
begin
  //dekrementieren
  temp:=strtoint(edit2.text);
  temp:=temp-1;
  edit2.Text:=inttostr(temp);
  zahlaendern();
end;

procedure TForm1.SpinButton1UpClick(Sender: TObject);
var
  temp:integer;
begin
  //inkrementieren
  temp:=strtoint(edit2.text);
  temp:=temp+1;
  edit2.Text:=inttostr(temp);
  zahlaendern();
end;


//----------------------------Sonstige Funktionen-----------------------------//


//Editieren der batch
procedure TForm1.batedit_buttonClick(Sender: TObject);
begin
  ShellExecute
         (Handle,
          NIL,
          //Editieren der batch
          PCHAR('notepad'),
          PCHAR(ExtractFilePath(Application.Exename)+'xplanet.bat'),
          NIL,
          SW_SHOW);
end;

//Ordner ffnen
procedure TForm1.oeffnen_buttonClick(Sender: TObject);
begin
    ShellExecute
         (Handle,
          NIL,
          //Pfad ffnen
          PCHAR('explorer'),
          PCHAR(ExtractFilePath(Application.Exename)),
          NIL,
          SW_SHOW);
end;


//------------------------Simple Button-Clicks etc----------------------------//


procedure TForm1.About1Click(Sender: TObject);
begin
  //Ein bisschen Werbung
  showmessage('Visit my blog at http://repat.de');
end;

procedure TForm1.Visible1Click(Sender: TObject);
begin
  //Konfigurations-Fenster zeigen
  form1.Visible:=true;
end;

procedure TForm1.DFTrayIcon1DblClick(Sender: TObject);
begin
  //Auf Doppelklick gleich Fenster anzeigen
  form1.show;
end;

procedure TForm1.tray_buttonClick(Sender: TObject);
begin
  //Form invis machen
  form1.Visible:=false;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Exit2Click(Sender: TObject);
begin
  close;
end;

//ShellExecute-Dummy
{begin
ShellExecute(0, Nil, PChar('cmd'), Pchar('xplanet.bat'), Pchar(''), SW_NORMAL);
end;}

procedure TForm1.Readme1Click(Sender: TObject);
begin
  form2.show;
end;

procedure TForm1.Jetztupdaten1Click(Sender: TObject);
begin
  timer1timer(sender);
end;

end.
